import { DynamicModule, Module, Provider } from '@nestjs/common';
import { RedisHelperService } from './redis-helper.service';

const dataSourceProviders = (dataSource: string): Provider => {
  return {
    provide: 'NAME_DATA_SOURCE',
    useFactory() {
      return dataSource;
    },
  };
};

const envProviders = (env: string): Provider => {
  return {
    provide: 'NODE_ENV',
    useFactory() {
      return env;
    },
  };
};

@Module({})
export class RedisHelperModule {
  static register(env: string, dataSource: string): DynamicModule {
    return {
      module: RedisHelperModule,
      providers: [dataSourceProviders(dataSource), envProviders(env)],
      exports: [RedisHelperService],
    };
  }
}
